2014多校聯合第9場1006||hdu 4965 矩陣乘法和快速冪
http://acm.hdu.edu.cn/showproblem.php?pid=4965
Problem Description
One day, Alice and Bob felt bored again, Bob knows Alice is a girl who loves math and is just learning something about matrix, so he decided to make a crazy problem for her.
Bob has a six-faced dice which has numbers 0, 1, 2, 3, 4 and 5 on each face. At first, he will choose a number N (4 <= N <= 1000), and for N times, he keeps throwing his dice for K times (2 <=K <= 6) and writes down its number on the top face to make an N*K matrix A, in which each element is not less than 0 and not greater than 5. Then he does similar thing again with a bit difference: he keeps throwing his dice for N times and each time repeat it for K times to write down a K*N matrix B, in which each element is not less than 0 and not greater than 5. With the two matrix A and B formed, Alice’s task is to perform the following 4-step calculation.
Step 1: Calculate a new N*N matrix C = A*B.
Step 2: Calculate M = C^(N*N).
Step 3: For each element x in M, calculate x % 6. All the remainders form a new matrix M’.
Step 4: Calculate the sum of all the elements in M’.
Bob just made this problem for kidding but he sees Alice taking it serious, so he also wonders what the answer is. And then Bob turn to you for help because he is not good at math.
Bob has a six-faced dice which has numbers 0, 1, 2, 3, 4 and 5 on each face. At first, he will choose a number N (4 <= N <= 1000), and for N times, he keeps throwing his dice for K times (2 <=K <= 6) and writes down its number on the top face to make an N*K matrix A, in which each element is not less than 0 and not greater than 5. Then he does similar thing again with a bit difference: he keeps throwing his dice for N times and each time repeat it for K times to write down a K*N matrix B, in which each element is not less than 0 and not greater than 5. With the two matrix A and B formed, Alice’s task is to perform the following 4-step calculation.
Step 1: Calculate a new N*N matrix C = A*B.
Step 2: Calculate M = C^(N*N).
Step 3: For each element x in M, calculate x % 6. All the remainders form a new matrix M’.
Step 4: Calculate the sum of all the elements in M’.
Bob just made this problem for kidding but he sees Alice taking it serious, so he also wonders what the answer is. And then Bob turn to you for help because he is not good at math.
Input
The input contains several test cases. Each test case starts with two integer N and K, indicating the numbers N and K described above. Then N lines follow, and each line has K integers between 0 and 5, representing matrix A. Then K lines follow, and each line
has N integers between 0 and 5, representing matrix B.
The end of input is indicated by N = K = 0.
The end of input is indicated by N = K = 0.
Output
For each case, output the sum of all the elements in M’ in a line.
Sample Input
4 2
5 5
4 4
5 4
0 0
4 2 5 5
1 3 1 5
6 3
1 2 3
0 3 0
2 3 4
4 3 2
2 5 5
0 5 0
3 4 5 1 1 0
5 3 2 3 3 2
3 1 5 4 5 2
0 0
Sample Output
14
56
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
int a[1005][6],b[6][1005],c[6][6],s[1005][1005],sum[1005][6];
const int MAX=6;
int n,m;
struct Matrix
{
int m[MAX][MAX];
};
Matrix I={1,0,0,0,0,0,
0,1,0,0,0,0,
0,0,1,0,0,0,
0,0,0,1,0,0,
0,0,0,0,1,0,
0,0,0,0,0,1};
Matrix matrixmul(Matrix a,Matrix b)
{
int i,j,k;
Matrix c;
for(i=0;i<m;i++)
for(j=0;j<m;j++)
{
c.m[i][j]=0;
for(k=0;k<m;k++)
c.m[i][j]+=(a.m[i][k]*b.m[k][j])%6;
c.m[i][j]%=6;
}
return c;
}
Matrix quickpow(Matrix P,int n)
{
Matrix m=P,b=I;
while(n>=1)
{
if(n&1)
b=matrixmul(b,m);
n=n>>1;
m=matrixmul(m,m);
}
return b;
}
int main()
{
while(~scanf("%d%d",&n,&m))
{
if(n==0&&m==0)
break;
memset(a,0,sizeof(a));
memset(b,0,sizeof(b));
memset(s,0,sizeof(s));
memset(c,0,sizeof(c));
memset(sum,0,sizeof(sum));
for(int i=0;i<n;i++)
for(int j=0;j<m;j++)
scanf("%d",&a[i][j]);
for(int i=0;i<m;i++)
for(int j=0;j<n;j++)
scanf("%d",&b[i][j]);
for(int i=0;i<m;i++)
for(int l=0;l<m;l++)
{
for(int j=0;j<n;j++)
c[i][l]+=b[i][j]*a[j][l];
}
/* for(int i=0;i<m;i++)
{
for(int j=0;j<m;j++)
printf("%d ",c[i][j]);
printf("\n");
}*/
Matrix A;
for(int i=0;i<m;i++)
for(int j=0;j<m;j++)
A.m[i][j]=c[i][j];
/* for(int i=0;i<m;i++)
{
for(int j=0;j<m;j++)
printf("%d ",A.m[i][j]);
printf("\n");
}*/
A=quickpow(A,n*n-1);
/* printf("\n");
for(int i=0;i<m;i++)
{
for(int j=0;j<m;j++)
printf("%d ",A.m[i][j]);
printf("\n");
}
printf("\n");
*/
for(int i=0;i<n;i++)
for(int j=0;j<m;j++)
for(int k=0;k<m;k++)
sum[i][j]+=a[i][k]*A.m[k][j];
for(int i=0;i<n;i++)
for(int k=0;k<n;k++)
{
for(int j=0;j<m;j++)
s[i][k]+=sum[i][j]*b[j][k];
s[i][k]%=6;
}
int ans=0;
for(int i=0;i<n;i++)
for(int j=0;j<n;j++)
ans+=s[i][j];
printf("%d\n",ans);
}
return 0;
}
相關文章
- 【矩陣乘法】【快速冪】遞推矩陣
- HDU 1005 Number Sequence(矩陣快速冪)矩陣
- POJ 3613 Cow Relays 矩陣乘法Floyd+矩陣快速冪矩陣
- HDU 2256Problem of Precision(矩陣快速冪)矩陣
- HDU 2157 How many ways?? (矩陣快速冪)矩陣
- HDU 2276 - Kiki & Little Kiki 2 (矩陣快速冪)矩陣
- 矩陣快速冪矩陣
- bzoj4887: [Tjoi2017]可樂(矩陣乘法+快速冪)矩陣
- 矩陣快速冪總結矩陣
- 矩陣快速冪(快忘了)矩陣
- 第?課——基於矩陣快速冪的遞推解法矩陣
- 矩陣快速冪加速最短路矩陣
- 矩陣快速冪最佳化矩陣
- 演算法學習:矩陣快速冪/矩陣加速演算法矩陣
- 2024杭電多校第9場
- HDU 4549 M斐波那契數列(矩陣快速冪+費馬小定理)矩陣
- 矩陣乘法矩陣
- bzoj4547: Hdu5171 小奇的集合(矩陣乘法)矩陣
- BZOJ 3329 Xorequ:數位dp + 矩陣快速冪矩陣
- 從斐波那契到矩陣快速冪矩陣
- cuda 加速矩陣乘法矩陣
- 【Triton 教程】矩陣乘法矩陣
- MKL庫矩陣乘法矩陣
- 04 矩陣乘法與線性變換複合矩陣
- 【矩陣乘法】Matrix Power Series矩陣
- 【dp+組合數學】hdu 2018 多校第九場 1001 Rikka with Nash Equilibrium hdu 6415UI
- 費馬小定理 + 費馬大定理 + 勾股數的求解 + 快速冪 + 矩陣快速冪 【模板】矩陣
- HDU 2197 本原串 (規律+快速冪)
- poj--2778DNA Sequence+AC自動機+矩陣快速冪矩陣
- BZOJ3329: Xorequ(二進位制數位dp 矩陣快速冪)矩陣
- 2020hdu多校8
- 怎樣用python計算矩陣乘法?Python矩陣
- CUDA 矩陣乘法終極優化指南矩陣優化
- torch中向量、矩陣乘法大總結矩陣
- 斐波那契數列Ⅳ【矩陣乘法】矩陣
- 2024杭電多校第8場
- 2024牛客多校第10場
- 2020HDU多校第三場 1005 Little W and Contest
- POJ 3233 Matrix Power Series (矩陣快速冪+等比數列二分求和)矩陣